#lang "qb"
'
' (C) Copyright 1997 James Paige
'
'Permission is hereby granted, free of charge, to any person obtaining a copy
'of this software and associated documentation files (the "Software"), to deal
'in the Software without restriction, including without limitation the rights
'to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
'copies of the Software, and to permit persons to whom the Software is
'furnished to do so, subject to the following conditions:
'
'The above copyright notice and this permission notice shall be included in
'all copies or substantial portions of the Software.
'
'THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
'IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
'FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
'AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
'LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
'OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
'THE SOFTWARE.
' ---------------------------------------------------------------------------
'
'Compile this game using FreeBasic
'
' ---------------------------------------------------------------------------
'$DYNAMIC
DECLARE FUNCTION addname$ (s$, n$, country$)
DECLARE FUNCTION MULTILINEINPUT$
DEFINT A-Z
CLS
SCREEN 1

DIM lines(40), desc$(40, 10), fail$(40), doable$(40, 25), do$(40, 25), dolimit(40), items(50), item$(50)

INPUT "Hello, my name is: (James) ", name$
name$ = LEFT$(name$, 8)
IF name$ = "" THEN name$ = "James"
PRINT "Your name is " + name$
INPUT "Country or state: (Slovenia) ", country$
country$ = LEFT$(country$, 8)
IF country$ = "" THEN country$ = "Slovenia"
PRINT "Adventuring in " + country$
LOCATE 6, 1: PRINT "To play, type a command and press enter."
LOCATE 7, 1: PRINT "Commands are usually verbs or nouns. If"
LOCATE 8, 1: PRINT "you get stuck, type HELP. If you want to"
LOCATE 9, 1: PRINT "stop playing, type QUIT. Type ITEMS to"
LOCATE 10, 1: PRINT "see what you are carying."
LINE (0, 39)-(319, 80), 1, B
ww$=INPUT(1)
GOSUB getrooms

DO
GOSUB descrip
GOSUB action
LOOP

descrip: CLS
LINE (4, 4)-(315, 88), 2, B
FOR i = 1 TO lines(room)
LOCATE i + 1, 2: PRINT desc$(room, i)
NEXT
RETURN

getrooms:
LOCATE 2, 1: PRINT "Loading..."
OPEN "rooms.str" FOR INPUT AS #1
INPUT #1, lastroom
LINE (9, 19)-(11 + lastroom * 2, 27), 1, B
FOR i = 0 TO lastroom
  LINE (10, 20)-(10 + i * 2, 26), 2, BF
  INPUT #1, lines(i)
  FOR o = 1 TO lines(i)
    desc$(i, o) = MULTILINEINPUT$()
    desc$(i, o) = addname$(desc$(i, o), name$, country$)
  NEXT
  fail$(i) = MULTILINEINPUT$()
  fail$(i) = addname$(fail$(i), name$, country$)
  INPUT #1, dolimit(i)
  FOR o = 1 TO dolimit(i)
    INPUT #1, doable$(i, o)
    do$(i, o) = MULTILINEINPUT$()
    do$(i, o) = addname$(do$(i, o), name$, country$)
  NEXT o
  INPUT #1, nul$
NEXT i
DO
  INPUT #1, num
  IF num = 51 THEN EXIT DO
  INPUT #1, item$(num)
  item$(num) = addname$(item$(num), name$, country$)
LOOP
RETURN

action:
LOCATE 13, 2: INPUT ":", w$: w$ = UCASE$(w$)
IF w$ = "?" THEN w$ = "HELP"
did = 0
IF w$ = "QUIT" THEN SYSTEM
IF w$ = "ITEM" OR w$ = "ITEMS" OR w$ = "INVENTORY" OR w$ = "I" THEN GOSUB listitems
i = 1: jumpto = 0
DO
IF UCASE$(w$) = UCASE$(LEFT$(doable$(room, i), LEN(doable$(room, i)) - 4)) OR UCASE$(LEFT$(doable$(room, i), LEN(doable$(room, i)) - 4)) = "?" THEN
 IF LEFT$(RIGHT$(doable$(room, i), 4), 1) = "!" THEN did = 1
 IF LEFT$(RIGHT$(doable$(room, i), 4), 1) = "@" THEN jumpto = VAL(RIGHT$(doable$(room, i), 3)): did = 1
 IF LEFT$(RIGHT$(doable$(room, i), 4), 1) = "#" THEN
  did = 2: have = 0
  FOR o = 0 TO 50
  IF items(o) = VAL(RIGHT$(doable$(room, i), 3)) THEN have = 1
  NEXT o: IF have = 0 THEN GOTO cond
 END IF
 IF LEFT$(RIGHT$(doable$(room, i), 4), 1) = "(" THEN
  did = 2: have = 0
  FOR o = 0 TO 50
  IF items(o) = VAL(RIGHT$(doable$(room, i), 3)) THEN have = 1
  NEXT o: IF have = 1 THEN GOTO cond
 END IF
 IF LEFT$(RIGHT$(doable$(room, i), 4), 1) = "$" THEN
  items(nopen) = VAL(RIGHT$(doable$(room, i), 3)): did = 1
  DO: nopen = nopen + 1: IF nopen > 50 THEN nopen = 0
  LOOP UNTIL items(nopen) = 0
 END IF
 IF LEFT$(RIGHT$(doable$(room, i), 4), 1) = "%" THEN
  did = 1: FOR o = 0 TO 50: IF items(o) = VAL(RIGHT$(doable$(room, i), 3)) THEN items(o) = 0
  NEXT o
 END IF
 IF do$(room, i) <> "" AND did = 1 THEN LOCATE 15, 1: PRINT do$(room, i): ww$ = INPUT$(1)
 IF jumpto > 0 THEN room = jumpto: GOTO noloop
END IF
i = i + 1
LOOP UNTIL i > dolimit(room)
IF did = 0 THEN LOCATE 15, 1: PRINT fail$(room): ww$ = INPUT$(1)
noloop:
RETURN
cond: IF do$(room, i) <> "" THEN LOCATE 15, 1: PRINT do$(room, i): ww$ = INPUT$(1)
GOTO noloop

listitems: CLS
o = 1: j = 1: did = 2
FOR i = 0 TO 50
IF items(i) > 0 AND items(i) < 41 THEN LOCATE o, j: PRINT item$(items(i)): o = o + 1: IF o > 20 THEN o = 1: j = 21
NEXT
ww$ = INPUT$(1)
RETURN

REM $STATIC
DEFSNG A-Z
FUNCTION addname$ (s$, n$, country$)
  IF s$ = "" THEN EXIT FUNCTION
  i = 1
  DO
    IF MID$(s$, i, 1) = "~" THEN
      a$ = LEFT$(s$, i - 1)
      B$ = RIGHT$(s$, LEN(s$) - i)
      s$ = a$ + n$ + B$
    END IF
    IF MID$(s$, i, 1) = "^" THEN
      a$ = LEFT$(s$, i - 1)
      B$ = RIGHT$(s$, LEN(s$) - i)
      s$ = a$ + country$ + B$
    END IF
    i = i + 1
  LOOP UNTIL i > LEN(s$)
  addname$ = s$
END FUNCTION

FUNCTION MULTILINEINPUT$
  LINE INPUT #1, s$
  s$ = RTRIM$(s$)
  IF RIGHT$(s$, 1) <> """" THEN
    s$ = s$ + CHR$(13) + CHR$(10)
    s$ = s$ + MULTILINEINPUT$()
  END IF
  IF LEFT$(s$, 1) = """" AND RIGHT$(s$, 1) = """" THEN
    s$ = MID$(s$, 2, LEN(s$) - 2)
  END IF
  MULTILINEINPUT$ = s$
END FUNCTION
